#pragma once

#include "CoreMinimal.h"
#include "EventDrivenModifierCondition.h"
#include "Templates/SubclassOf.h"
#include "OwningPlayerHasStatusEffectOfClass.generated.h"

class UStatusEffect;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDCOMPETENCE_API UOwningPlayerHasStatusEffectOfClass : public UEventDrivenModifierCondition
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_IsConditionMet, meta=(AllowPrivateAccess=true))
	bool _isConditionMet;

public:
	UFUNCTION(BlueprintCallable)
	void SetClassTypeToMatch(TSubclassOf<UStatusEffect> classType);

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_IsConditionMet();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UOwningPlayerHasStatusEffectOfClass();
};

FORCEINLINE uint32 GetTypeHash(const UOwningPlayerHasStatusEffectOfClass) { return 0; }
